<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_131) on Mon Jul 17 12:51:56 CEST 2017 -->
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>BasePlayer (APP)</title>
<meta name="date" content="2017-07-17">
<link rel="stylesheet" type="text/css" href="../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="BasePlayer (APP)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":6,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],4:["t3","Abstract Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/BasePlayer.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../index-all.html">Index</a></li>
<li><a href="../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../towerwarspp/player/Adv2Player.html" title="class in towerwarspp.player"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../towerwarspp/player/HumanPlayer.html" title="class in towerwarspp.player"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../index.html?towerwarspp/player/BasePlayer.html" target="_top">Frames</a></li>
<li><a href="BasePlayer.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">towerwarspp.player</div>
<h2 title="Class BasePlayer" class="title">Class BasePlayer</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>towerwarspp.player.BasePlayer</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd>java.rmi.Remote, <a href="../../towerwarspp/preset/Player.html" title="interface in towerwarspp.preset">Player</a></dd>
</dl>
<dl>
<dt>Direct Known Subclasses:</dt>
<dd><a href="../../towerwarspp/player/Adv1Player.html" title="class in towerwarspp.player">Adv1Player</a>, <a href="../../towerwarspp/player/Adv2Player.html" title="class in towerwarspp.player">Adv2Player</a>, <a href="../../towerwarspp/player/HumanPlayer.html" title="class in towerwarspp.player">HumanPlayer</a>, <a href="../../towerwarspp/player/RndPlayer.html" title="class in towerwarspp.player">RndPlayer</a>, <a href="../../towerwarspp/player/SimplePlayer.html" title="class in towerwarspp.player">SimplePlayer</a></dd>
</dl>
<hr>
<br>
<pre>public abstract class <span class="typeNameLabel">BasePlayer</span>
extends java.lang.Object
implements <a href="../../towerwarspp/preset/Player.html" title="interface in towerwarspp.preset">Player</a></pre>
<div class="block">Partial implementation of Player Interface that is used as Super-Class for specialized players (eg. Human, Random, etc.).
 The request(), confirm(), makeMove() and init() method are implemented and thus are the same for all subclasses. By using
 the enum PlayerState it is guaranteed that the methods are always called in the correct order. All players have their own Board
 instance on which they place their own and their opponent moves. If the State of the board is ILLEGAL or does'nt match
 with the passed States in confirm() and makeMove() an exception is thrown.</div>
<dl>
<dt><span class="simpleTagLabel">Version:</span></dt>
<dd>07-07-17</dd>
<dt><span class="simpleTagLabel">Author:</span></dt>
<dd>Alexander Wähling</dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>(package private) <a href="../../towerwarspp/board/Board.html" title="class in towerwarspp.board">Board</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/player/BasePlayer.html#board">board</a></span></code>
<div class="block">Board instance on which the player places all his own and opponent moves.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>(package private) <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/player/BasePlayer.html#color">color</a></span></code>
<div class="block">Color of this Player instance</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private <a href="../../towerwarspp/util/debug/Debug.html" title="class in towerwarspp.util.debug">Debug</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/player/BasePlayer.html#debug">debug</a></span></code>
<div class="block"><a href="../../towerwarspp/util/debug/Debug.html" title="class in towerwarspp.util.debug"><code>Debug</code></a> Debug instance to log messages.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private <a href="../../towerwarspp/player/PlayerState.html" title="enum in towerwarspp.player">PlayerState</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/player/BasePlayer.html#state">state</a></span></code>
<div class="block">State that represents the point in the request - confirm - makeMove cycle of the Player</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../towerwarspp/player/BasePlayer.html#BasePlayer--">BasePlayer</a></span>()</code>&nbsp;</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t3" class="tableTab"><span><a href="javascript:show(4);">Abstract Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/player/BasePlayer.html#confirm-towerwarspp.preset.Status-">confirm</a></span>(<a href="../../towerwarspp/preset/Status.html" title="enum in towerwarspp.preset">Status</a>&nbsp;boardStatus)</code>
<div class="block">Method to validate the players boardStatus against the passed one.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>(package private) abstract <a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/player/BasePlayer.html#deliverMove--">deliverMove</a></span>()</code>
<div class="block">Only abstract method.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code><a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/player/BasePlayer.html#getColor--">getColor</a></span>()</code>
<div class="block">Returns the current <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset"><code>PlayerColor</code></a></div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>(package private) <a href="../../towerwarspp/preset/Viewer.html" title="interface in towerwarspp.preset">Viewer</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/player/BasePlayer.html#getViewer--">getViewer</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/player/BasePlayer.html#init-int-towerwarspp.preset.PlayerColor-">init</a></span>(int&nbsp;size,
    <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;color)</code>
<div class="block">Method to initialize current Player.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code><a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/player/BasePlayer.html#request--">request</a></span>()</code>
<div class="block">Request method as specified in the <a href="../../towerwarspp/preset/Player.html" title="interface in towerwarspp.preset"><code>Player</code></a> Interface.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/player/BasePlayer.html#setBoard-towerwarspp.board.Board-">setBoard</a></span>(<a href="../../towerwarspp/board/Board.html" title="class in towerwarspp.board">Board</a>&nbsp;board)</code>
<div class="block">sets the <a href="../../towerwarspp/board/Board.html" title="class in towerwarspp.board"><code>Board</code></a> of the Player to given Board and updates the <a href="../../towerwarspp/player/PlayerState.html" title="enum in towerwarspp.player"><code>PlayerState</code></a>.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/player/BasePlayer.html#update-towerwarspp.preset.Move-towerwarspp.preset.Status-">update</a></span>(<a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&nbsp;opponentMove,
      <a href="../../towerwarspp/preset/Status.html" title="enum in towerwarspp.preset">Status</a>&nbsp;boardStatus)</code>
<div class="block">Update own board with opponentMove  and check if opponents board status is equal to own board status.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="debug">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>debug</h4>
<pre>private final&nbsp;<a href="../../towerwarspp/util/debug/Debug.html" title="class in towerwarspp.util.debug">Debug</a> debug</pre>
<div class="block"><a href="../../towerwarspp/util/debug/Debug.html" title="class in towerwarspp.util.debug"><code>Debug</code></a> Debug instance to log messages.</div>
</li>
</ul>
<a name="board">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>board</h4>
<pre><a href="../../towerwarspp/board/Board.html" title="class in towerwarspp.board">Board</a> board</pre>
<div class="block">Board instance on which the player places all his own and opponent moves. Is used to guarantee
 that no moves are played that are considered Illegal by ones own Board implementation (necessary for remote play)</div>
</li>
</ul>
<a name="color">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>color</h4>
<pre><a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a> color</pre>
<div class="block">Color of this Player instance</div>
</li>
</ul>
<a name="state">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>state</h4>
<pre>private&nbsp;<a href="../../towerwarspp/player/PlayerState.html" title="enum in towerwarspp.player">PlayerState</a> state</pre>
<div class="block">State that represents the point in the request - confirm - makeMove cycle of the Player</div>
</li>
</ul>
</li>
</ul>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="BasePlayer--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>BasePlayer</h4>
<pre>public&nbsp;BasePlayer()</pre>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="getColor--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getColor</h4>
<pre>public&nbsp;<a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;getColor()</pre>
<div class="block">Returns the current <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset"><code>PlayerColor</code></a></div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the color of the Player</dd>
</dl>
</li>
</ul>
<a name="getViewer--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getViewer</h4>
<pre><a href="../../towerwarspp/preset/Viewer.html" title="interface in towerwarspp.preset">Viewer</a>&nbsp;getViewer()</pre>
</li>
</ul>
<a name="setBoard-towerwarspp.board.Board-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setBoard</h4>
<pre>public&nbsp;void&nbsp;setBoard(<a href="../../towerwarspp/board/Board.html" title="class in towerwarspp.board">Board</a>&nbsp;board)</pre>
<div class="block">sets the <a href="../../towerwarspp/board/Board.html" title="class in towerwarspp.board"><code>Board</code></a> of the Player to given Board and updates the <a href="../../towerwarspp/player/PlayerState.html" title="enum in towerwarspp.player"><code>PlayerState</code></a>.
 used for loading and replaying games</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>board</code> - the new board</dd>
</dl>
</li>
</ul>
<a name="request--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>request</h4>
<pre>public&nbsp;<a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&nbsp;request()
             throws java.lang.Exception</pre>
<div class="block">Request method as specified in the <a href="../../towerwarspp/preset/Player.html" title="interface in towerwarspp.preset"><code>Player</code></a> Interface. Can only be called after <a href="../../towerwarspp/player/BasePlayer.html#init-int-towerwarspp.preset.PlayerColor-"><code>init(int, PlayerColor)</code></a> or
 <a href="../../towerwarspp/player/BasePlayer.html#update-towerwarspp.preset.Move-towerwarspp.preset.Status-"><code>update(Move, Status)</code></a>. Makes a call to <a href="../../towerwarspp/player/BasePlayer.html#deliverMove--"><code>deliverMove()</code></a>, places the move on own <a href="../../towerwarspp/player/BasePlayer.html#board"><code>board</code></a> and
 optionally calls view.visualize() if view != null. Also sets <a href="../../towerwarspp/player/BasePlayer.html#state"><code>state</code></a> to the next state by calling <a href="../../towerwarspp/player/PlayerState.html#next--"><code>PlayerState.next()</code></a>.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../towerwarspp/preset/Player.html#request--">request</a></code>&nbsp;in interface&nbsp;<code><a href="../../towerwarspp/preset/Player.html" title="interface in towerwarspp.preset">Player</a></code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the Move the player wishes to make</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.lang.Exception</code> - if the method is called in an incorrect order</dd>
</dl>
</li>
</ul>
<a name="confirm-towerwarspp.preset.Status-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>confirm</h4>
<pre>public&nbsp;void&nbsp;confirm(<a href="../../towerwarspp/preset/Status.html" title="enum in towerwarspp.preset">Status</a>&nbsp;boardStatus)
             throws java.lang.Exception</pre>
<div class="block">Method to validate the players boardStatus against the passed one. <b>Must always</b> be called after request and <b>before</b> confirm!</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../towerwarspp/preset/Player.html#confirm-towerwarspp.preset.Status-">confirm</a></code>&nbsp;in interface&nbsp;<code><a href="../../towerwarspp/preset/Player.html" title="interface in towerwarspp.preset">Player</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>boardStatus</code> - boardStatus to validate</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.lang.Exception</code> - Throws an Exception in case the method is invoked in the wrong order, or own <a href="../../towerwarspp/board/SimpleBoard.html#status"><code>SimpleBoard.status</code></a>
                   diifers from passed one, or is <a href="../../towerwarspp/preset/Status.html#ILLEGAL"><code>Status.ILLEGAL</code></a>.</dd>
</dl>
</li>
</ul>
<a name="update-towerwarspp.preset.Move-towerwarspp.preset.Status-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>update</h4>
<pre>public&nbsp;void&nbsp;update(<a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&nbsp;opponentMove,
                   <a href="../../towerwarspp/preset/Status.html" title="enum in towerwarspp.preset">Status</a>&nbsp;boardStatus)
            throws java.lang.Exception</pre>
<div class="block">Update own board with opponentMove  and check if opponents board status is equal to own board status. If status are
 unequal of own board status is ILLEGAL an exception is thrown.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../towerwarspp/preset/Player.html#update-towerwarspp.preset.Move-towerwarspp.preset.Status-">update</a></code>&nbsp;in interface&nbsp;<code><a href="../../towerwarspp/preset/Player.html" title="interface in towerwarspp.preset">Player</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>opponentMove</code> - opponent move to place on own board</dd>
<dd><code>boardStatus</code> - opponent board status after move</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.lang.Exception</code> - is thrown if method is called in wrong order, or status is ILLEGAL or different from passed status</dd>
</dl>
</li>
</ul>
<a name="init-int-towerwarspp.preset.PlayerColor-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>init</h4>
<pre>public&nbsp;void&nbsp;init(int&nbsp;size,
                 <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;color)
          throws java.lang.Exception</pre>
<div class="block">Method to initialize current Player. A new Board is created with specified board size and color is set to passed
 color. Also if view != null it's setViewer() method is called with the board.viewer() as argument and view.visualize()
 is called.
 <a href="../../towerwarspp/player/BasePlayer.html#state"><code>state</code></a> is set depending on passed color. If <a href="../../towerwarspp/preset/PlayerColor.html#BLUE"><code>PlayerColor.BLUE</code></a> is passed state is set to UPDATE,
 if <a href="../../towerwarspp/preset/PlayerColor.html#RED"><code>PlayerColor.RED</code></a> is set to REQUEST.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../towerwarspp/preset/Player.html#init-int-towerwarspp.preset.PlayerColor-">init</a></code>&nbsp;in interface&nbsp;<code><a href="../../towerwarspp/preset/Player.html" title="interface in towerwarspp.preset">Player</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>size</code> - size of <a href="../../towerwarspp/board/Board.html" title="class in towerwarspp.board"><code>Board</code></a> to play on.</dd>
<dd><code>color</code> - <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset"><code>PlayerColor</code></a> of player</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.lang.Exception</code></dd>
</dl>
</li>
</ul>
<a name="deliverMove--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>deliverMove</h4>
<pre>abstract&nbsp;<a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&nbsp;deliverMove()
                   throws java.lang.Exception</pre>
<div class="block">Only abstract method. Is called inside the request method. Subclasses of BasePlayer should put their logic into
 their implementation of deliverMove(). This way it is guaranteed that all Player classes share the same
 request - confirm - makeMove - init logic and their only difference is the specific Move returned by request()
 depending on their type.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Move that the Player intends to make</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.lang.Exception</code></dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/BasePlayer.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../index-all.html">Index</a></li>
<li><a href="../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../towerwarspp/player/Adv2Player.html" title="class in towerwarspp.player"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../towerwarspp/player/HumanPlayer.html" title="class in towerwarspp.player"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../index.html?towerwarspp/player/BasePlayer.html" target="_top">Frames</a></li>
<li><a href="BasePlayer.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
